<?php

/**
 * @file
 * Admin page callbacks for the currencylayer currency converter module.
 */

 /**
  * Configuration form for the currencylayer currency converter settings.
  */
function currencylayer_currency_converter_settings_form($form_state, &$from_state) {
  $form = array();
  $form['currency_converter'] = array(
    '#type' => 'fieldset',
    '#title' => t('Please Select Your Defaut Block Currency'),
  );
  $form['currency_converter']['currencylayer_currency_converter_from'] = array(
    '#type' => 'select',
    '#title' => t('Select Your Currency From'),
    '#options' => currencylayer_currency_converter_country_list(),
    '#default_value' => variable_get('currencylayer_currency_converter_from', ''),
    '#required' => TRUE,
  );
  $form['currency_converter']['currencylayer_currency_converter_to'] = array(
    '#type' => 'select',
    '#title' => t('Select Your Currency To'),
    '#options' => currencylayer_currency_converter_country_list(),
    '#default_value' => variable_get('currencylayer_currency_converter_to', ''),
    '#required' => TRUE,
  );
  $form['currency_converter']['currencylayer_api_key'] = array(
    '#type' => 'textfield',
    '#required' => TRUE,
    '#default_value' => variable_get('currencylayer_api_key'),
    '#title' => t('Currencylayer currency Api Key'),
    '#description' => t('Enter Currencylayer Currency Api Key for Apilayer'),
  );
  return system_settings_form($form);
}

/**
 * Validates the submitted currencylayer currency converter settings form.
 */
function currencylayer_currency_converter_settings_form_validate(&$form, &$form_state) {
  if ($form_state['values']['currencylayer_currency_converter_from'] == $form_state['values']['currencylayer_currency_converter_to']) {
    form_set_error('currencylayer_currency_converter_to', t('Please select different currency both currency are same.'));
  }
  else {
    $url = "http://www.apilayer.net/api/live?access_key=" . $form_state['values']['currencylayer_api_key'];
    $request = curl_init();
    $timeout = 30;
    curl_setopt($request, CURLOPT_URL, $url);
    curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($request, CURLOPT_CONNECTTIMEOUT, $timeout);
    $results = curl_exec($request);
    curl_close($request);
    $currencylayer_converter_rate_array = json_decode($results);

    if ($currencylayer_converter_rate_array->success != 'true') {
      form_set_error('currencylayer_api_key', t('Please provide valid currencylayer API key.'));
    }
  }
}
